/**
* @module vue-mdc-adaptermenu 0.10.0
* @exports VueMDCMenu
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"material-components-web":"^0.30.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueMDCMenu=t()}(this,function(){"use strict";function e(e,t,n){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=void 0;"function"==typeof CustomEvent?r=new CustomEvent(t,{detail:n,bubbles:i}):(r=document.createEvent("CustomEvent")).initCustomEvent(t,i,!1,n),e.dispatchEvent(r)}var t=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},n=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),i=function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e},r=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(e[i]=n[i])}return e},o=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},s=function(){function e(){var n=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};t(this,e),this.adapter_=n}return n(e,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),n(e,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),e}(),a=(function(){function e(){t(this,e)}n(e,[{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"hasClass",value:function(e){}},{key:"hasNecessaryDom",value:function(){}},{key:"getAttributeForEventTarget",value:function(e,t){}},{key:"getInnerDimensions",value:function(){}},{key:"hasAnchor",value:function(){}},{key:"getAnchorDimensions",value:function(){}},{key:"getWindowDimensions",value:function(){}},{key:"getNumberOfItems",value:function(){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}},{key:"registerBodyClickHandler",value:function(e){}},{key:"deregisterBodyClickHandler",value:function(e){}},{key:"getIndexForEventTarget",value:function(e){}},{key:"notifySelected",value:function(e){}},{key:"notifyCancel",value:function(){}},{key:"saveFocus",value:function(){}},{key:"restoreFocus",value:function(){}},{key:"isFocused",value:function(){}},{key:"focus",value:function(){}},{key:"getFocusedItemIndex",value:function(){}},{key:"focusItemAtIndex",value:function(e){}},{key:"isRtl",value:function(){}},{key:"setTransformOrigin",value:function(e){}},{key:"setPosition",value:function(e){}},{key:"setMaxHeight",value:function(e){}},{key:"setAttrForOptionAtIndex",value:function(e,t,n){}},{key:"rmAttrForOptionAtIndex",value:function(e,t){}},{key:"addClassForOptionAtIndex",value:function(e,t){}},{key:"rmClassForOptionAtIndex",value:function(e,t){}}])}(),{ROOT:"mdc-menu",OPEN:"mdc-menu--open",ANIMATING_OPEN:"mdc-menu--animating-open",ANIMATING_CLOSED:"mdc-menu--animating-closed",SELECTED_LIST_ITEM:"mdc-list-item--selected"}),u={ITEMS_SELECTOR:".mdc-menu__items",SELECTED_EVENT:"MDCMenu:selected",CANCEL_EVENT:"MDCMenu:cancel",ARIA_DISABLED_ATTR:"aria-disabled"},c={SELECTED_TRIGGER_DELAY:50,TRANSITION_OPEN_DURATION:120,TRANSITION_CLOSE_DURATION:75,MARGIN_TO_EDGE:32,ANCHOR_TO_MENU_WIDTH_RATIO:.67,OFFSET_TO_MENU_HEIGHT_RATIO:.1},d={BOTTOM:1,CENTER:2,RIGHT:4,FLIP_RTL:8},l={TOP_LEFT:0,TOP_RIGHT:d.RIGHT,BOTTOM_LEFT:d.BOTTOM,BOTTOM_RIGHT:d.BOTTOM|d.RIGHT,TOP_START:d.FLIP_RTL,TOP_END:d.FLIP_RTL|d.RIGHT,BOTTOM_START:d.BOTTOM|d.FLIP_RTL,BOTTOM_END:d.BOTTOM|d.RIGHT|d.FLIP_RTL},h=function(e){function h(e){t(this,h);var n=o(this,(h.__proto__||Object.getPrototypeOf(h)).call(this,r(h.defaultAdapter,e)));return n.clickHandler_=function(e){return n.handlePossibleSelected_(e)},n.keydownHandler_=function(e){return n.handleKeyboardDown_(e)},n.keyupHandler_=function(e){return n.handleKeyboardUp_(e)},n.documentClickHandler_=function(e){return n.handleDocumentClick_(e)},n.isOpen_=!1,n.openAnimationEndTimerId_=0,n.closeAnimationEndTimerId_=0,n.selectedTriggerTimerId_=0,n.animationRequestId_=0,n.dimensions_,n.itemHeight_,n.anchorCorner_=l.TOP_START,n.anchorMargin_={top:0,right:0,bottom:0,left:0},n.measures_=null,n.selectedIndex_=-1,n.rememberSelection_=!1,n.quickOpen_=!1,n.keyDownWithinMenu_=!1,n}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(h,s),n(h,null,[{key:"cssClasses",get:function(){return a}},{key:"strings",get:function(){return u}},{key:"numbers",get:function(){return c}},{key:"Corner",get:function(){return l}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},hasClass:function(){return!1},hasNecessaryDom:function(){return!1},getAttributeForEventTarget:function(){},getInnerDimensions:function(){return{}},hasAnchor:function(){return!1},getAnchorDimensions:function(){return{}},getWindowDimensions:function(){return{}},getNumberOfItems:function(){return 0},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerBodyClickHandler:function(){},deregisterBodyClickHandler:function(){},getIndexForEventTarget:function(){return 0},notifySelected:function(){},notifyCancel:function(){},saveFocus:function(){},restoreFocus:function(){},isFocused:function(){return!1},focus:function(){},getFocusedItemIndex:function(){return-1},focusItemAtIndex:function(){},isRtl:function(){return!1},setTransformOrigin:function(){},setPosition:function(){},setMaxHeight:function(){},setAttrForOptionAtIndex:function(){},rmAttrForOptionAtIndex:function(){},addClassForOptionAtIndex:function(){},rmClassForOptionAtIndex:function(){}}}}]),n(h,[{key:"init",value:function(){var e=h.cssClasses,t=e.ROOT,n=e.OPEN;if(!this.adapter_.hasClass(t))throw new Error(t+" class required in root element.");if(!this.adapter_.hasNecessaryDom())throw new Error("Required DOM nodes missing in "+t+" component.");this.adapter_.hasClass(n)&&(this.isOpen_=!0),this.adapter_.registerInteractionHandler("click",this.clickHandler_),this.adapter_.registerInteractionHandler("keyup",this.keyupHandler_),this.adapter_.registerInteractionHandler("keydown",this.keydownHandler_)}},{key:"destroy",value:function(){clearTimeout(this.selectedTriggerTimerId_),clearTimeout(this.openAnimationEndTimerId_),clearTimeout(this.closeAnimationEndTimerId_),cancelAnimationFrame(this.animationRequestId_),this.adapter_.deregisterInteractionHandler("click",this.clickHandler_),this.adapter_.deregisterInteractionHandler("keyup",this.keyupHandler_),this.adapter_.deregisterInteractionHandler("keydown",this.keydownHandler_),this.adapter_.deregisterBodyClickHandler(this.documentClickHandler_)}},{key:"setAnchorCorner",value:function(e){this.anchorCorner_=e}},{key:"setAnchorMargin",value:function(e){this.anchorMargin_.top="number"==typeof e.top?e.top:0,this.anchorMargin_.right="number"==typeof e.right?e.right:0,this.anchorMargin_.bottom="number"==typeof e.bottom?e.bottom:0,this.anchorMargin_.left="number"==typeof e.left?e.left:0}},{key:"setRememberSelection",value:function(e){this.rememberSelection_=e,this.setSelectedIndex(-1)}},{key:"setQuickOpen",value:function(e){this.quickOpen_=e}},{key:"focusOnOpen_",value:function(e){if(null===e){if(this.rememberSelection_&&this.selectedIndex_>=0)return void this.adapter_.focusItemAtIndex(this.selectedIndex_);this.adapter_.focus(),this.adapter_.isFocused()||this.adapter_.focusItemAtIndex(0)}else this.adapter_.focusItemAtIndex(e)}},{key:"handleDocumentClick_",value:function(e){for(var t=e.target;t&&t!==document.documentElement;){if(-1!==this.adapter_.getIndexForEventTarget(t))return;t=t.parentNode}this.adapter_.notifyCancel(),this.close(e)}},{key:"handleKeyboardDown_",value:function(e){if(e.altKey||e.ctrlKey||e.metaKey)return!0;var t=e.keyCode,n=e.key,i=e.shiftKey,r="Tab"===n||9===t,o="ArrowUp"===n||38===t,s="ArrowDown"===n||40===t,a="Space"===n||32===t,u="Enter"===n||13===t;this.keyDownWithinMenu_=u||a;var c=this.adapter_.getFocusedItemIndex(),d=this.adapter_.getNumberOfItems()-1;return i&&r&&0===c?(this.adapter_.focusItemAtIndex(d),e.preventDefault(),!1):!i&&r&&c===d?(this.adapter_.focusItemAtIndex(0),e.preventDefault(),!1):((o||s||a)&&e.preventDefault(),o?0===c||this.adapter_.isFocused()?this.adapter_.focusItemAtIndex(d):this.adapter_.focusItemAtIndex(c-1):s&&(c===d||this.adapter_.isFocused()?this.adapter_.focusItemAtIndex(0):this.adapter_.focusItemAtIndex(c+1)),!0)}},{key:"handleKeyboardUp_",value:function(e){if(e.altKey||e.ctrlKey||e.metaKey)return!0;var t=e.keyCode,n=e.key,i="Escape"===n||27===t;return("Enter"===n||13===t||("Space"===n||32===t))&&(this.keyDownWithinMenu_&&this.handlePossibleSelected_(e),this.keyDownWithinMenu_=!1),i&&(this.adapter_.notifyCancel(),this.close()),!0}},{key:"handlePossibleSelected_",value:function(e){var t=this;if("true"!==this.adapter_.getAttributeForEventTarget(e.target,u.ARIA_DISABLED_ATTR)){var n=this.adapter_.getIndexForEventTarget(e.target);n<0||this.selectedTriggerTimerId_||(this.selectedTriggerTimerId_=setTimeout(function(){t.selectedTriggerTimerId_=0,t.close(),t.rememberSelection_&&t.setSelectedIndex(n),t.adapter_.notifySelected({index:n})},c.SELECTED_TRIGGER_DELAY))}}},{key:"getAutoLayoutMeasurements_",value:function(){var e=this.adapter_.getAnchorDimensions(),t=this.adapter_.getWindowDimensions();return{viewport:t,viewportDistance:{top:e.top,right:t.width-e.right,left:e.left,bottom:t.height-e.bottom},anchorHeight:e.height,anchorWidth:e.width,menuHeight:this.dimensions_.height,menuWidth:this.dimensions_.width}}},{key:"getOriginCorner_",value:function(){var e=l.TOP_LEFT,t=this.measures_,n=t.viewportDistance,i=t.anchorHeight,r=t.anchorWidth,o=t.menuHeight,s=t.menuWidth,a=Boolean(this.anchorCorner_&d.BOTTOM),u=a?n.top+i+this.anchorMargin_.bottom:n.top+this.anchorMargin_.top,c=o-(a?n.bottom-this.anchorMargin_.bottom:n.bottom+i-this.anchorMargin_.top);c>0&&o-u<c&&(e|=d.BOTTOM);var h=this.adapter_.isRtl(),f=Boolean(this.anchorCorner_&d.FLIP_RTL),m=Boolean(this.anchorCorner_&d.RIGHT),_=m&&!h||!m&&f&&h,p=s-(_?n.left+r+this.anchorMargin_.right:n.left+this.anchorMargin_.left),g=s-(_?n.right-this.anchorMargin_.right:n.right+r-this.anchorMargin_.left);return(p<0&&_&&h||m&&!_&&p<0||g>0&&p<g)&&(e|=d.RIGHT),e}},{key:"getHorizontalOriginOffset_",value:function(e){var t=this.measures_.anchorWidth,n=Boolean(e&d.RIGHT),i=Boolean(this.anchorCorner_&d.RIGHT),r=0;if(n){r=i?t-this.anchorMargin_.left:this.anchorMargin_.right}else{r=i?t-this.anchorMargin_.right:this.anchorMargin_.left}return r}},{key:"getVerticalOriginOffset_",value:function(e){var t=this.measures_,n=t.viewport,i=t.viewportDistance,r=t.anchorHeight,o=t.menuHeight,s=Boolean(e&d.BOTTOM),a=h.numbers.MARGIN_TO_EDGE,u=Boolean(this.anchorCorner_&d.BOTTOM),c=!u,l=0;return s?(l=u?r-this.anchorMargin_.top:-this.anchorMargin_.bottom,c&&o>i.top+r&&(l=-(Math.min(o,n.height-a)-(i.top+r)))):(l=u?r+this.anchorMargin_.bottom:this.anchorMargin_.top,c&&o>i.bottom+r&&(l=-(Math.min(o,n.height-a)-(i.bottom+r)))),l}},{key:"getMenuMaxHeight_",value:function(e){var t=0,n=this.measures_.viewportDistance,i=Boolean(e&d.BOTTOM);return this.anchorCorner_&d.BOTTOM&&(t=i?n.top+this.anchorMargin_.top:n.bottom-this.anchorMargin_.bottom),t}},{key:"autoPosition_",value:function(){var e;if(this.adapter_.hasAnchor()){this.measures_=this.getAutoLayoutMeasurements_();var t=this.getOriginCorner_(),n=this.getMenuMaxHeight_(t),r=t&d.BOTTOM?"bottom":"top",o=t&d.RIGHT?"right":"left",s=this.getHorizontalOriginOffset_(t),a=this.getVerticalOriginOffset_(t),u=(e={},i(e,o,s?s+"px":"0"),i(e,r,a?a+"px":"0"),e),l=this.measures_,h=l.anchorWidth,f=l.menuHeight;if(h/l.menuWidth>c.ANCHOR_TO_MENU_WIDTH_RATIO&&(o="center"),!(this.anchorCorner_&d.BOTTOM)&&Math.abs(a/f)>c.OFFSET_TO_MENU_HEIGHT_RATIO){var m=100*Math.abs(a/f),_=t&d.BOTTOM?100-m:m;r=Math.round(100*_)/100+"%"}this.adapter_.setTransformOrigin(o+" "+r),this.adapter_.setPosition(u),this.adapter_.setMaxHeight(n?n+"px":""),this.measures_=null}}},{key:"open",value:function(){var e=this,t=(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{}).focusIndex,n=void 0===t?null:t;this.adapter_.saveFocus(),this.quickOpen_||this.adapter_.addClass(h.cssClasses.ANIMATING_OPEN),this.animationRequestId_=requestAnimationFrame(function(){e.dimensions_=e.adapter_.getInnerDimensions(),e.autoPosition_(),e.adapter_.addClass(h.cssClasses.OPEN),e.focusOnOpen_(n),e.adapter_.registerBodyClickHandler(e.documentClickHandler_),e.quickOpen_||(e.openAnimationEndTimerId_=setTimeout(function(){e.openAnimationEndTimerId_=0,e.adapter_.removeClass(h.cssClasses.ANIMATING_OPEN)},c.TRANSITION_OPEN_DURATION))}),this.isOpen_=!0}},{key:"close",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;!!t&&"true"===this.adapter_.getAttributeForEventTarget(t.target,u.ARIA_DISABLED_ATTR)||(this.adapter_.deregisterBodyClickHandler(this.documentClickHandler_),this.quickOpen_||this.adapter_.addClass(h.cssClasses.ANIMATING_CLOSED),requestAnimationFrame(function(){e.adapter_.removeClass(h.cssClasses.OPEN),e.quickOpen_||(e.closeAnimationEndTimerId_=setTimeout(function(){e.closeAnimationEndTimerId_=0,e.adapter_.removeClass(h.cssClasses.ANIMATING_CLOSED)},c.TRANSITION_CLOSE_DURATION))}),this.isOpen_=!1,this.adapter_.restoreFocus())}},{key:"isOpen",value:function(){return this.isOpen_}},{key:"getSelectedIndex",value:function(){return this.selectedIndex_}},{key:"setSelectedIndex",value:function(e){if(e!==this.selectedIndex_){var t=this.selectedIndex_;t>=0&&(this.adapter_.rmAttrForOptionAtIndex(t,"aria-selected"),this.adapter_.rmClassForOptionAtIndex(t,a.SELECTED_LIST_ITEM)),this.selectedIndex_=e>=0&&e<this.adapter_.getNumberOfItems()?e:-1,this.selectedIndex_>=0&&(this.adapter_.setAttrForOptionAtIndex(this.selectedIndex_,"aria-selected","true"),this.adapter_.addClassForOptionAtIndex(this.selectedIndex_,a.SELECTED_LIST_ITEM))}}}]),h}(),f=void 0,m=function(e){return{version:"0.10.0",install:function(t){for(var n in e){var i=e[n];t.component(i.name,i)}},components:e}}({mdcMenu:{render:function(){var e=this.$createElement,t=this._self._c||e;return t("div",{ref:"root",staticClass:"mdc-menu mdc-simple-menu",class:this.classes,style:this.styles,attrs:{tabindex:"-1"}},[t("ul",{ref:"items",staticClass:"mdc-simple-menu__items mdc-list",attrs:{role:"menu","aria-hidden":"true"}},[this._t("default")],2)])},staticRenderFns:[],name:"mdc-menu",props:{"open-from-top-left":Boolean,"open-from-top-right":Boolean,"open-from-bottom-left":Boolean,"open-from-bottom-right":Boolean},data:function(){return{classes:{"mdc-simple-menu--open-from-top-left":this.openFromTopLeft,"mdc-simple-menu--open-from-top-right":this.openFromTopRight,"mdc-simple-menu--open-from-bottom-left":this.openFromBottomLeft,"mdc-simple-menu--open-from-bottom-right":this.openFromBottomRight},styles:{},items:[]}},methods:{show:function(e){this.foundation.open(e)},hide:function(){this.foundation.close()},isOpen:function(){return!!this.foundation&&this.foundation.isOpen()}},mounted:function(){var t=this,n=function(){t.items=[].slice.call(t.$refs.items.querySelectorAll(".mdc-list-item[role]")),t.$emit("update")};this.slotObserver=new MutationObserver(function(){return n()}),this.slotObserver.observe(this.$el,{childList:!0,subtree:!0}),this._previousFocus=void 0,this.foundation=new h({addClass:function(e){return t.$set(t.classes,e,!0)},removeClass:function(e){return t.$delete(t.classes,e)},hasClass:function(e){return t.$refs.root.classList.contains(e)},hasNecessaryDom:function(){return Boolean(t.$refs.items)},getAttributeForEventTarget:function(e,t){return e.getAttribute(t)},getInnerDimensions:function(){return{width:t.$refs.items.offsetWidth,height:t.$refs.items.offsetHeight}},hasAnchor:function(){return t.$refs.root.parentElement&&t.$refs.root.parentElement.classList.contains("mdc-menu-anchor")},getAnchorDimensions:function(){return t.$refs.root.parentElement.getBoundingClientRect()},getWindowDimensions:function(){return{width:window.innerWidth,height:window.innerHeight}},getNumberOfItems:function(){return t.items.length},registerInteractionHandler:function(e,n){return t.$refs.root.addEventListener(e,n)},deregisterInteractionHandler:function(e,n){return t.$refs.root.removeEventListener(e,n)},registerBodyClickHandler:function(e){return document.body.addEventListener("click",e)},deregisterBodyClickHandler:function(e){return document.body.removeEventListener("click",e)},getIndexForEventTarget:function(e){return t.items.indexOf(e)},notifySelected:function(n){var i={index:n.index,item:t.items[n.index]};t.$emit("select",i),e(t.$el,h.strings.SELECTED_EVENT,i)},notifyCancel:function(){t.$emit("cancel"),e(t.$el,h.strings.CANCEL_EVENT,{})},saveFocus:function(){t._previousFocus=document.activeElement},restoreFocus:function(){t._previousFocus&&t._previousFocus.focus()},isFocused:function(){return document.activeElement===t.$refs.root},focus:function(){return t.$refs.root.focus()},getFocusedItemIndex:function(){return t.items.indexOf(document.activeElement)},focusItemAtIndex:function(e){return t.items[e].focus()},isRtl:function(){return"rtl"===getComputedStyle(t.$refs.root).getPropertyValue("direction")},setTransformOrigin:function(e){t.$set(t.styles,function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===f||t){var n="transform"in e.document.createElement("div").style?"transform":"webkitTransform";f=n}return f}(window)+"-origin",e)},setPosition:function(e){t.$set(t.styles,"left",e.left),t.$set(t.styles,"right",e.right),t.$set(t.styles,"top",e.top),t.$set(t.styles,"bottom",e.bottom)},setMaxHeight:function(e){t.$set(t.styles,"max-height",e)},setAttrForOptionAtIndex:function(e,n,i){t.items[e].setAttribute(n,i)},rmAttrForOptionAtIndex:function(e,n){t.items[e].removeAttribute(n)},addClassForOptionAtIndex:function(e,n){t.items[e].classList.add(n)},rmClassForOptionAtIndex:function(e,n){t.items[e].classList.remove(n)}}),n(),this.foundation.init()},beforeDestroy:function(){this._previousFocus=null,this.slotObserver.disconnect(),this.foundation.destroy()}},mdcMenuItem:{render:function(){var e=this.$createElement;return(this._self._c||e)("li",{staticClass:"mdc-menu-item mdc-list-item",attrs:{role:"menuitem",tabindex:this.disabled?"-1":"0","aria-disabled":this.disabled}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-menu-item",props:{disabled:Boolean}},mdcMenuDivider:{render:function(){var e=this.$createElement;return(this._self._c||e)("li",{staticClass:"mdc-menu-divider mdc-list-divider",attrs:{role:"separator"}})},staticRenderFns:[],name:"mdc-menu-divider"},mdcMenuAnchor:{render:function(){var e=this.$createElement;return(this._self._c||e)("div",{staticClass:"mdc-menu-anchor"},[this._t("default")],2)},staticRenderFns:[],name:"mdc-menu-anchor"}});return function(e){var t=null;"undefined"!=typeof window?t=window.Vue:"undefined"!=typeof global&&(t=global.Vue),t&&t.use(e)}(m),m});
//# sourceMappingURL=menu.min.js.map
